package com.caimei.config;

import com.caimei.components.RedisService;
import com.caimei.mapper.LoginMapper;
import com.caimei.model.vo.WxClubUserVo;
import com.caimei.service.LoginService;
import com.caimei.utils.JwtUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.HandlerInterceptor;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Description
 *
 * @author : Aslee
 * @date : 2021/7/21
 */
@Component
public class WxApiInterceptor implements HandlerInterceptor {

    private RedisService redisService;

    @Autowired
    public void setRedisService(RedisService redisService) {
        this.redisService = redisService;
    }

    @Resource
    private LoginMapper loginMapper;

    @Value("${caimei.zplmapi}")
    private String zplmapi;

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        String token = request.getHeader("X-Token");
        String cacheOpenId = null != token ? (null != redisService.get(token) ? String.valueOf(redisService.get(token)) : null) : null;
        // 验证机构用户是否可以登录
        WxClubUserVo clubUser = loginMapper.findClubUser(cacheOpenId);
        if (null == cacheOpenId || null == clubUser) {
            // Token失效
            response.sendRedirect(zplmapi + "/unauthorized");
            return false;
        }
        return true;
    }

}
