package com.caimei.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.caimei.config.FastDfsClient;
import com.caimei.service.UploadService;
import com.caimei.utils.OSSUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URI;
import java.net.URL;
import java.util.UUID;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

/**
 * Description
 *
 * @author : Aslee
 * @date : 2021/5/11
 */
@Slf4j
@Service
public class UploadServiceImpl implements UploadService {

    @Autowired
    private FastDfsClient client;

    @Value("${spring.profiles.active}")
    private String active;

    @Value("${caimei.imageDomain}")
    private String imageDomain;

    @Override
    public String saveFile(MultipartFile file) throws IOException {
        String originalFilename = file.getOriginalFilename();
        String randomUUID = UUID.randomUUID().toString();
        int index = originalFilename.lastIndexOf(".");
        String exet = originalFilename.substring(index);
        String filePath = "/mnt/newdatadrive/data/runtime/jar-instance/zplma/tempImage/";
        if ("dev".equals(active)){
            filePath = "D:\\uploadImage\\";
        }
        filePath += "\\" + randomUUID + exet;
        file.transferTo(new File(filePath));
        log.info(">>>>>>>>>>>>>>>>图片上传路径:" + filePath);
        return client.uploadFile(filePath);
    }


    @Override
    public String saveImageZip(JSONArray imageArr) throws Exception {
        String randomUUID = UUID.randomUUID().toString();
        String filePath = "/mnt/newdatadrive/data/runtime/jar-instance/zplma/tempImage/";
        if ("dev".equals(active)){
            filePath = "D:\\uploadZip\\";
        }
        filePath += randomUUID + ".zip";
        File zipFile = new File(filePath);
        ZipOutputStream out = new ZipOutputStream(new FileOutputStream(zipFile));
        BufferedOutputStream bo = new BufferedOutputStream(out);
        for (Object s : imageArr) {
            String imageUrl = s.toString();
            HttpURLConnection httpUrl = (HttpURLConnection) new URL(imageUrl).openConnection();
            httpUrl.connect();
            String imgRandomId = UUID.randomUUID().toString();
            File image = inputStreamToFile(httpUrl.getInputStream(), imgRandomId + ".png");
            out.putNextEntry(new ZipEntry(image.getName()));
            FileInputStream in = new FileInputStream(image);
            BufferedInputStream bi = new BufferedInputStream(in);
            int b;
            while ((b = bi.read()) != -1) {
                bo.write(b);
            }
            bo.flush();
            bi.close();
            in.close();
        }
        bo.close();
        out.close();
        return imageDomain + "/" + client.uploadFile(filePath);
    }


    /**
     *   工具类
     * inputStream 转 File
     */
    public static File inputStreamToFile(InputStream ins, String name) throws Exception{
        File file = new File(System.getProperty("java.io.tmpdir") + File.separator + name);
        if (file.exists()) {
            return file;
        }
        OutputStream os = new FileOutputStream(file);
        int bytesRead;
        int len = 8192;
        byte[] buffer = new byte[len];
        while ((bytesRead = ins.read(buffer, 0, len)) != -1) {
            os.write(buffer, 0, bytesRead);
        }
        os.close();
        ins.close();
        return file;
    }
}
